<?php

namespace NoccyLabs\React\Http2\Frame;

use NoccyLabs\React\Http2\Header\HeaderBag;
use NoccyLabs\React\Http2\Header\HeaderPacker;

class HeadersFrame extends Frame
{
    static ?HeaderPacker $headerPacker = null;

    public readonly HeaderBag $headers;

    public function fromBinary(string $binary): void
    {
        if (!self::$headerPacker)
            self::$headerPacker = new HeaderPacker();

        $this->headers = self::$headerPacker->unpackHeaders($binary);
    }

    public function toBinary(): string
    {
        return self::$headerPacker->packHeaders($this->headers);
    }
}

